# -*- coding: utf-8 -*-

from datetime import date, timedelta
from babel.core import Locale
from babel.dates import format_date


def print_calendar(d, locale, out):
    d -= timedelta(days=(d.weekday() - locale.first_week_day + 7) % 7)
    out.write('        |')
    for n in xrange(7):
        out.write(format_date(d + timedelta(days=n), format=' EEE',
                              locale=locale))
    out.write('\n')
    for w in xrange(2):
        # Workaround to retreive week number, use last day instead of
        # first day in this week.
        first_day = d + timedelta(days=7 * w)
        last_day = d + timedelta(days=7 * w + 6)
        out.write(format_date(last_day, format="YYYY'W'ww |",
                              locale=locale))
        for n in xrange(7):
            out.write(' %2d ' % (d + timedelta(days=7 * w + n)).day)
        out.write('\n')
    out.write('\n')


def main(start='2006', end='2009', locale='de_DE'):
    locale = Locale.parse(locale)
    for year in xrange(int(start), int(end) + 1):
        print_calendar(date(year, 12, 31), locale, sys.stdout)


if __name__ == '__main__':
    import sys
    main(*sys.argv[1:])
